package com.eactive.eai.batch.job.jobItem.cfa;

import java.io.ByteArrayOutputStream;

import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.common.exception.ExceptionUtil;

public class RECV_CFABT_0800 extends DefaultTelegram implements TelegramService
{
//    //>> 업무관리정보
//    private final String OpCode_start       = "001";    //업무개시
//    private final String OpCode_restart     = "002";    //업무재개시
//    private final String OpCode_end         = "040";    //업무종료
//    private final String OpCode_teset       = "301";    //회선시험


    /**
     * 생성자
     */
    public RECV_CFABT_0800() {
        //여신금융협회 개시/종료/통신망 전문
    }

    /**
     * 전문 해체하기
     */
    public boolean doExecute() {
        if (!super.doExecute()) return false;
        return true;
    }

    /**
     * 전문 Validation
     */
    public boolean doValidation()
    {
        if (!super.doValidation()) return false;

//        //업무관리정보 유효성 확인
//        if (this.getOpCode().equalsIgnoreCase(this.OpCode_start)) {
//        }
//        else if(this.getOpCode().equalsIgnoreCase(this.OpCode_restart)) {
//        	String bizCode = super.getFieldValueString(0).substring(3);
//        	String processCode = batchDoc.getBatchMsg().getHeader().getProcessCode();
//        	BatchJobInfoVO jvo = DirInfoManager.getInstance().getFileInfoByDstcd(processCode, bizCode);
//        	if ( jvo != null ){
//            	batchDoc.getBatchMsg().getHeader().setBizCode(bizCode);
//            	batchDoc.getBatchMsg().getHeader().setJobCode(jvo.getMsgDstCode());
//        	}
//        }
//        else if(this.getOpCode().equalsIgnoreCase(this.OpCode_end)) {
//        }
//        else if(this.getOpCode().equalsIgnoreCase(this.OpCode_teset)) {
//        }
//        else {
//            logger.info("{} 0800 telegram : unknown  Operation code received >> "+this.getOpCode(), logHeader);
//            this.setResolveResponseCode("94");
//
//            String[] msgArgs = new String[2];
//            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
//            msgArgs[1] = this.getOpCode();
//            String errCode = "BECEAIFJI008";
//            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
//            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
//
//        }
        return true;
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
			//DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<14; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            batchDoc.getBatchMsg().setTelegramBody("");
            
            batchDoc.getBatchMsg().getBody().setRecvFld01(new String((byte[])this.al_Field.get(1)));
            batchDoc.getBatchMsg().getBody().setRecvFld04(new String((byte[])this.al_Field.get(4)));
            batchDoc.getBatchMsg().getBody().setRecvFld07(new String((byte[])this.al_Field.get(7)));
            batchDoc.getBatchMsg().getBody().setRecvFld08(new String((byte[])this.al_Field.get(8)));
            batchDoc.getBatchMsg().getBody().setRecvFld09(new String((byte[])this.al_Field.get(9)));
            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
		return super.getFieldValueString(3);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
		return super.getFieldValueString(7);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(12);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
		return super.getFieldValueString(11);
    }
}
